#include "stdafx.h"
#include "dialog.h"
#include "resource.h"
#include "commctrl.h"




INT_PTR CALLBACK DlgProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			// Initialise configuration dialog
			SendDlgItemMessage(hWnd,IDC_SPIN,UDM_SETRANGE,0,MAKELONG(60,1));

			CHAR c[100];
			sprintf(&c[0],"%d",FrameRate);
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"1");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"2");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"4");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"8");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"10");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"12");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"15");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"18");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"21");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"24");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"25");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"27");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"28");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"30");

			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_SELECTSTRING,0,(LPARAM)&c[0]);
			SetDlgItemText(hWnd,IDC_FRAMERATE,&c[0]);
			SendDlgItemMessage(hWnd,IDC_MULTITHREAD,BM_SETCHECK,MultiThread,0);
		}
		break;
	case WM_CLOSE:EndDialog(hWnd,0);
		break;
	case WM_COMMAND:
		if (wParam==IDC_MAIL)
		{
			ShellExecute(hWnd,"open","mailto:mail@saschahlusiak.de",NULL,NULL,SW_SHOW);
		}
		if (wParam==IDC_HP)
		{
			ShellExecute(hWnd,"open","http://www.saschahlusiak.de",NULL,NULL,SW_SHOW);
		}
		if (wParam==IDOK)
		{
			CHAR c[100];
			GetDlgItemText(hWnd,IDC_FRAMERATE,&c[0],100);
			int i=atoi(&c[0]);
			if (i==0)MessageBox(hWnd,"Invalid framerate. Enter a valid framerate or pick one from the list.","Try again, looser.",MB_OK|MB_ICONEXCLAMATION);
			else {
				char s[100];
				extern char* iniFile;
				FrameRate=i;
				MultiThread=(BOOLEAN)SendDlgItemMessage(hWnd,IDC_MULTITHREAD,BM_GETCHECK,0,0);
				sprintf(s,"%d",FrameRate);
				WritePrivateProfileString("AviWCX","FrameRate",s,iniFile);
				FrameRate=GetPrivateProfileInt("AviWCX","FrameRate",30,iniFile);
				EndDialog(hWnd,1);
			}
		}
		if (wParam==IDCANCEL)EndDialog(hWnd,0);
		break;
	default:return FALSE;
	}
	return TRUE;
}

void RunConfigDialog(HWND Parent,HINSTANCE DllInstance)
{
	// Opends the configuration dialog
	DialogBox(DllInstance,MAKEINTRESOURCE(IDD_CONFIG),Parent,DlgProc);
}